import os
import json

import ahocorasick

from em_tasks.store.models import *


class BlacklistFilter():
  def __init__(self):
    # self.filter_cache_path = os.path.abspath(os.path.expanduser('~'), '.em_tasks', 'blacklist_filter.json')
    # filter_cache_dir = os.path.dirname(self.filter_cache_path)
    # if not os.path.isdir(filter_cache_dir):
    #   os.makedirs(filter_cache_dir)

    self.automaton = ahocorasick.Automaton()
    idx = 0
    for keyword in BlacklistKeyword.select().order_by(BlacklistKeyword.id.desc()).dicts():
      k = keyword['keywords'].strip().lower()
      if not k:
        continue

      self.automaton.add_word(k, (idx, k))
      idx += 1

    self.automaton.make_automaton()

  def is_blacklisted(self, s):
    end_idx, (pos, val) = next(self.automaton.iter(s), (None, (None, None)))
    if not val:
      return False

    return val

  # def load_cache(self):
  #   if not os.path.isfile(self.filter_cache_path):
  #     return

  #   with open(self.filter_cache_path, encoding='utf-8', errors='ignore') as fh:
  #     s = fh.read().strip()
  #     filter_cache = json.loads(s)
  #     if 'keywords' not in filter_cache or not filter_cache['keywords']:
  #       return
